package com.huimv.manager.entity.dto;

import cn.hutool.core.date.DateUtil;
import com.huimv.manager.utils.Constant;
import lombok.Data;
import org.apache.commons.lang.StringUtils;
import org.hibernate.validator.constraints.Range;

import javax.validation.constraints.NotBlank;
import java.util.Date;

/**
 * <p>
 *
 * </p>
 *
 * @author yinhao
 * @date 2021/7/28 15:06
 */
@Data
public class DataAnalysisDto {

    @NotBlank(message = "区域代码不能为空!")
    private String regionCode;

    private String start;

    private String end;

    @Range(min = 1, max = 3,message = "请传递指定的type参数!")
    private Integer type;

    public String getStart() {
        return start;
    }

    public void setStart(String start) {
        this.start = start;
    }

    public String getEnd() {
        return end;
    }

    public void setEnd(String end) {
        this.end = end;
    }


    public String getDayStart() {
        if (StringUtils.isEmpty(start)) {
            return Constant.SDF_YMD.format(DateUtil.offsetMonth(DateUtil.date(), -1));
        }
        return start;
    }

    public String getDayEnd() {
        if (StringUtils.isEmpty(end)) {
            return Constant.SDF_YMD.format(new Date());
        }
        return end;
    }

    public String getMonthStart() {
        if (StringUtils.isEmpty(start)) {
            return Constant.SDF_YM.format(DateUtil.offsetMonth(new Date(), -12)) + "-01";
        }
        return start + "-01";
    }

    public String getMonthEnd() {
        Date nowDate = new Date();
        if (StringUtils.isEmpty(end) || end.equals(Constant.SDF_YM.format(nowDate))) {
            return Constant.SDF_YMD.format(nowDate);
        }
        return Constant.SDF_YMD.format(DateUtil.endOfMonth(DateUtil.parse(end, Constant.DATE_FORMAT_YM)));
    }

    public String getYearStart() {
        if (StringUtils.isEmpty(start)) {
            return DateUtil.offsetMonth(new Date(), -60).year() + "-01-01";
        }
        return start + "-01-01";
    }

    public String getYearEnd() {
        Date nowDate = new Date();
        if (StringUtils.isEmpty(end) || end.equals(DateUtil.format(nowDate, Constant.DATE_FORMAT_Y))) {
            return Constant.SDF_YMD.format(nowDate);
        }
        return Constant.SDF_YMD.format(DateUtil.endOfYear(DateUtil.parse(end, Constant.DATE_FORMAT_Y)));
    }
}
